{
  "custom": {},
  "params": {
    "configuring": false,
    "equipmentPath": "Enterprise\\El Dorado Hills\\Packaging Area\\Packaging Line 1",
    "timePeriod": "Current Shift",
    "title": "OEE Waterfall"
  },
  "propConfig": {
    "params.configuring": {
      "onChange": {
        "enabled": null,
        "script": "\tviewParams\u003dself.params\n\tconfigParams\u003dself.getChild(\"root/configuration\").props.params\n\tif currentValue.value:\n\t\tconfigParams.equipmentPathIn \u003d viewParams.equipmentPath\t\n\t\tconfigParams.timePeriodIn \u003d viewParams.timePeriod\n\t\tconfigParams.titleIn \u003d viewParams.title\n\telif previousValue is not None and previousValue.value:\n\t\tviewParams.equipmentPath \u003d configParams.equipmentPathOut\n\t\tviewParams.timePeriod \u003d configParams.timePeriodOut\n\t\tviewParams.title \u003d configParams.titleOut"
      },
      "paramDirection": "input",
      "persistent": true
    },
    "params.equipmentPath": {
      "paramDirection": "inout",
      "persistent": true
    },
    "params.timePeriod": {
      "paramDirection": "inout",
      "persistent": true
    },
    "params.title": {
      "paramDirection": "inout",
      "persistent": true
    }
  },
  "props": {},
  "root": {
    "children": [
      {
        "meta": {
          "name": "Widget Title"
        },
        "propConfig": {
          "meta.visible": {
            "binding": {
              "config": {
                "expression": "!{view.params.configuring}"
              },
              "type": "expr"
            }
          },
          "props.params.text": {
            "binding": {
              "config": {
                "path": "view.params.title"
              },
              "type": "property"
            }
          }
        },
        "props": {
          "path": "Page/Embedded/Widget Title"
        },
        "type": "ia.display.view"
      },
      {
        "meta": {
          "name": "configuration"
        },
        "position": {
          "display": false
        },
        "propConfig": {
          "position.display": {
            "binding": {
              "config": {
                "path": "view.params.configuring"
              },
              "type": "property"
            },
            "persistent": true
          }
        },
        "props": {
          "params": {
            "equipmentPathIn": "",
            "equipmentPathOut": "",
            "timePeriodIn": "",
            "timePeriodOut": "",
            "titleIn": "OEE Waterfall",
            "titleOut": "OEE Waterfall"
          },
          "path": "Page/Widgets/Configuration/Equipment Path, Time Period, Title"
        },
        "type": "ia.display.view"
      },
      {
        "children": [
          {
            "meta": {
              "name": "XYChart_1"
            },
            "position": {
              "grow": 1
            },
            "propConfig": {
              "props.dataSources": {
                "binding": {
                  "config": {
                    "struct": {
                      "end": "tag(runScript(\u0027shared.mes.schedule.getTagPathForTimePeriodEnd\u0027, 0, {view.params.timePeriod}, {view.params.equipmentPath}))",
                      "equipmentPath": "{view.params.equipmentPath}",
                      "start": "tag(runScript(\u0027shared.mes.schedule.getTagPathForTimePeriodStart\u0027, 0, {view.params.timePeriod}, {view.params.equipmentPath}))",
                      "time": "now(60000)"
                    },
                    "waitOnAll": true
                  },
                  "enabled": false,
                  "transforms": [
                    {
                      "code": "\timport time\n\tif value[\u0027equipmentPath\u0027] and value[\u0027start\u0027] and value[\u0027end\u0027]:\n\t\tasList \u003d system.mes.analysis.getMESAnalysisSettingsList()\n\t\tif \u0027OEE Losses Waterfall\u0027 not in asList:\n\t\t\tanalysisSetting \u003d system.mes.analysis.createMESAnalysisSettings(\u0027OEE Losses Waterfall\u0027)\n\t\t\tdatapoints \u003d [\n\t\t\t\t\t\t\"Elapsed Time\",\n\t\t\t\t\t\t\"Runtime\",\n\t\t\t\t\t\t\"Planned Downtime\",\n\t\t\t\t\t\t\"Unplanned Downtime\",\n\t\t\t\t\t\t\"Infeed Standard Count\",\n\t\t\t\t\t\t\"Outfeed Standard Count\",\n\t\t\t\t\t\t\"Standard Rate\",\n\t\t\t\t\t\t\"OEE\",\n\t\t\t\t\t\t\"OEE Availability\",\n\t\t\t\t\t\t\"OEE Performance\",\n\t\t\t\t\t\t\"OEE Quality\",\n\t\t\t\t\t\t\"OEE Infeed Count\",\n\t\t\t\t\t\t\"OEE Reject Count\",\n\t\t\t\t\t\t\"OEE Outfeed Count\"\n\t\t\t\t\t\t]\n\t\t\tanalysisSetting.setDataPoints(datapoints)\n\t\t\tanalysisSetting.addParameter(\u0027eqPath\u0027)\n\t\t\tanalysisSetting.setFilterExpression(\"Equipment Path \u003d @eqPath\")\n\t\t\tsystem.mes.analysis.saveMESAnalysisSettings(analysisSetting)\n\t\tresults \u003d system.mes.analysis.executeAnalysis(value[\u0027start\u0027], value[\u0027end\u0027], \u0027OEE Losses Waterfall\u0027, {\u0027eqPath\u0027:value[\u0027equipmentPath\u0027]})\n\t\t\n\t\tds \u003d results.getDataset()\n\t\tif ds.getRowCount() \u003e 0:\n\t\t\telapsedTime \u003d ds.getValueAt(0, \u0027Elapsed Time\u0027)\n\t\t\tplannedDowntime \u003d ds.getValueAt(0, \u0027Planned Downtime\u0027)\n\t\t\tplannedTime \u003d elapsedTime - plannedDowntime\n\t\t\tunplannedDowntime \u003d ds.getValueAt(0, \u0027Unplanned Downtime\u0027)\n\t\t\tstandardRate \u003d ds.getValueAt(0, \u0027Standard Rate\u0027)\n\t\t\truntime \u003d ds.getValueAt(0, \u0027Runtime\u0027)\n\t\t\tplannedtime \u003d elapsedTime - plannedDowntime\n\t\t\tif plannedTime \u003d\u003d 0:\n\t\t\t\tplannedTime \u003d None\n\t\t\tif plannedDowntime \u003d\u003d 0:\n\t\t\t\tplannedDowntime \u003d None\n\t\t\toutfeedCount \u003d ds.getValueAt(0, \u0027OEE Outfeed Count\u0027)\n\t\t\trejectCount \u003d ds.getValueAt(0, \u0027OEE Reject Count\u0027)\n\t\t\tif standardRate \u003e 0:\n\t\t\t\tperfTime \u003d outfeedCount / standardRate\n\t\t\t\tqualTime \u003d rejectCount / standardRate\n\t\t\t\t\n\t\t\t\theader \u003d [\"Label\",\"Time\",\"Planned Downtime\",\"Unplanned Downtime\",\"Performance Loss\",\"Quality Loss\"]\n\t\t\t\tdata \u003d [[\u0027Elapsed Time\u0027, elapsedTime, None, None, None,None]]\n\t\t\t\tdata.append([\u0027Planned Time\u0027, plannedTime, plannedDowntime, None,None, None])\n\t\t\t\tdata.append([\u0027Run Time\u0027, runtime, None, unplannedDowntime, None, None])\n\t\t\t\tdata.append([\u0027Production Time\u0027, runtime - perfTime, None, None, perfTime, None])\n\t\t\t\tdata.append([\u0027Quality Time\u0027, runtime - perfTime - qualTime, None,None, None, qualTime])\n\t\t\t\tnewDS \u003d system.dataset.toDataSet(header, data)\n\t\t\t\tnewDS \u003d system.dataset.toDataSet(header, data)\n\t\t\t\tdataSet \u003d system.dataset.toPyDataSet(newDS)\n\t\t\t\treturnResult \u003d []\n\t\t\t\tfor row in dataSet:\n\t\t\t\t\tresult \u003d {}\n\t\t\t\t\tfor index,data in enumerate(row):\n\t\t\t\t\t\tresult[str(dataSet.getColumnName(index))] \u003d data\n\t\t\t\t\treturnResult.append(result)\n\t\t\t\tself.props.dataSources \u003d system.dataset.toDataSet([], [])\n\t\t\t\ttime.sleep(0.01)\n\t\t\t\treturn({\u0027oeeData\u0027:returnResult})\n\treturn {}",
                      "type": "script"
                    }
                  ],
                  "type": "expr-struct"
                }
              }
            },
            "props": {
              "background": {
                "color": "#C0C0C000",
                "render": "color"
              },
              "cursor": {
                "lineX": {
                  "enabled": false
                },
                "series": "oeeData"
              },
              "dataSources": {
                "$": [
                  "ds",
                  192,
                  1712785384438
                ],
                "$columns": []
              },
              "scrollBars": {
                "horizontal": {
                  "series": "production schedule"
                }
              },
              "series": [
                {
                  "candlestick": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "stacked": false,
                      "stroke": {
                        "color": "",
                        "opacity": 1,
                        "width": 1
                      }
                    },
                    "high": {
                      "x": "",
                      "y": ""
                    },
                    "low": {
                      "x": "",
                      "y": ""
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "column": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "color",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "#72B15A",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "height": null,
                      "stacked": true,
                      "stroke": {
                        "color": "#72B15A",
                        "opacity": 1,
                        "width": 1
                      },
                      "width": null
                    },
                    "open": {
                      "x": 0,
                      "y": ""
                    }
                  },
                  "data": {
                    "source": "oeeData",
                    "x": "Time",
                    "y": "Label"
                  },
                  "defaultState": {
                    "visible": true
                  },
                  "hiddenInLegend": false,
                  "label": {
                    "text": ""
                  },
                  "line": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": true,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "name": "Time",
                  "render": "column",
                  "stepLine": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": true,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": true,
                    "pointerLength": 4,
                    "text": "{name}: [bold]{valueX}[/]"
                  },
                  "visible": true,
                  "xAxis": "customTime",
                  "yAxis": "Label",
                  "zIndex": 0
                },
                {
                  "candlestick": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "stacked": false,
                      "stroke": {
                        "color": "",
                        "opacity": 1,
                        "width": 1
                      }
                    },
                    "high": {
                      "x": "",
                      "y": ""
                    },
                    "low": {
                      "x": "",
                      "y": ""
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "column": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "#ED2830",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "height": null,
                      "stacked": true,
                      "stroke": {
                        "color": "#ED2830",
                        "opacity": 1,
                        "width": 1
                      },
                      "width": null
                    },
                    "open": {
                      "x": 0,
                      "y": ""
                    }
                  },
                  "data": {
                    "source": "oeeData",
                    "x": "Unplanned Downtime",
                    "y": "Label"
                  },
                  "defaultState": {
                    "visible": true
                  },
                  "hiddenInLegend": false,
                  "label": {
                    "text": ""
                  },
                  "line": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": false,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "name": "Unplanned Downtime",
                  "render": "column",
                  "stepLine": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": true,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": true,
                    "pointerLength": 4,
                    "text": "{name}: [bold]{valueX}[/]"
                  },
                  "visible": true,
                  "xAxis": "customTime",
                  "yAxis": "Label",
                  "zIndex": 0
                },
                {
                  "candlestick": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "stacked": false,
                      "stroke": {
                        "color": "",
                        "opacity": 1,
                        "width": 1
                      }
                    },
                    "high": {
                      "x": "",
                      "y": ""
                    },
                    "low": {
                      "x": "",
                      "y": ""
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "column": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "#7B7AC3",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "height": null,
                      "stacked": true,
                      "stroke": {
                        "color": "#7B7AC3",
                        "opacity": 1,
                        "width": 1
                      },
                      "width": null
                    },
                    "open": {
                      "x": 0,
                      "y": ""
                    }
                  },
                  "data": {
                    "source": "oeeData",
                    "x": "Performance Loss",
                    "y": "Label"
                  },
                  "defaultState": {
                    "visible": true
                  },
                  "hiddenInLegend": false,
                  "label": {
                    "text": ""
                  },
                  "line": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": false,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "name": "Performance Loss",
                  "render": "column",
                  "stepLine": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": true,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": true,
                    "pointerLength": 4,
                    "text": "{name}: [bold]{valueX}[/]"
                  },
                  "visible": true,
                  "xAxis": "customTime",
                  "yAxis": "Label",
                  "zIndex": 0
                },
                {
                  "candlestick": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "stacked": false,
                      "stroke": {
                        "color": "",
                        "opacity": 1,
                        "width": 1
                      }
                    },
                    "high": {
                      "x": "",
                      "y": ""
                    },
                    "low": {
                      "x": "",
                      "y": ""
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "column": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "#DD9C5D",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "height": null,
                      "stacked": true,
                      "stroke": {
                        "color": "#DD9C5D",
                        "opacity": 1,
                        "width": 1
                      },
                      "width": null
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "data": {
                    "source": "oeeData",
                    "x": "Quality Loss",
                    "y": "Label"
                  },
                  "defaultState": {
                    "visible": true
                  },
                  "hiddenInLegend": false,
                  "label": {
                    "text": ""
                  },
                  "line": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": false,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "name": "Quality Loss",
                  "render": "column",
                  "stepLine": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": true,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": true,
                    "pointerLength": 4,
                    "text": "{name}: [bold]{valueX}[/]"
                  },
                  "visible": true,
                  "xAxis": "customTime",
                  "yAxis": "Label",
                  "zIndex": 0
                },
                {
                  "candlestick": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "stacked": false,
                      "stroke": {
                        "color": "",
                        "opacity": 1,
                        "width": 1
                      }
                    },
                    "high": {
                      "x": "",
                      "y": ""
                    },
                    "low": {
                      "x": "",
                      "y": ""
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "column": {
                    "appearance": {
                      "deriveFieldsFromData": {
                        "fill": {
                          "color": "",
                          "opacity": ""
                        },
                        "stroke": {
                          "color": "",
                          "opacity": "",
                          "width": ""
                        }
                      },
                      "fill": {
                        "color": "#1707FB",
                        "opacity": 1
                      },
                      "heatRules": {
                        "dataField": "",
                        "enabled": false,
                        "max": "",
                        "min": ""
                      },
                      "height": null,
                      "stacked": true,
                      "stroke": {
                        "color": "",
                        "opacity": 1,
                        "width": 1
                      },
                      "width": null
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "data": {
                    "source": "oeeData",
                    "x": "Planned Downtime",
                    "y": "Label"
                  },
                  "defaultState": {
                    "visible": true
                  },
                  "hiddenInLegend": false,
                  "label": {
                    "text": ""
                  },
                  "line": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": false,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "name": "Planned Downtime",
                  "render": "column",
                  "stepLine": {
                    "appearance": {
                      "bullets": [
                        {
                          "deriveFieldsFromData": {
                            "fill": {
                              "color": "",
                              "opacity": ""
                            },
                            "rotation": "",
                            "stroke": {
                              "color": "",
                              "opacity": "",
                              "width": ""
                            }
                          },
                          "enabled": true,
                          "fill": {
                            "color": "",
                            "opacity": 1
                          },
                          "heatRules": {
                            "dataField": "",
                            "enabled": false,
                            "max": 100,
                            "min": 2
                          },
                          "height": 10,
                          "label": {
                            "position": {
                              "dx": 0,
                              "dy": 0
                            },
                            "text": "{value}"
                          },
                          "render": "circle",
                          "rotation": 0,
                          "stroke": {
                            "color": "",
                            "opacity": 1,
                            "width": 1
                          },
                          "tooltip": {
                            "background": {
                              "color": "",
                              "opacity": 1
                            },
                            "cornerRadius": 3,
                            "enabled": true,
                            "pointerLength": 4,
                            "text": "{name}: [bold]{valueY}[/]"
                          },
                          "width": 10
                        }
                      ],
                      "connect": true,
                      "fill": {
                        "color": "",
                        "opacity": 0
                      },
                      "minDistance": 0.5,
                      "stroke": {
                        "color": "",
                        "dashArray": "",
                        "opacity": 1,
                        "width": 3
                      },
                      "tensionX": 1,
                      "tensionY": 1
                    },
                    "open": {
                      "x": "",
                      "y": ""
                    }
                  },
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": true,
                    "pointerLength": 4,
                    "text": "{name}: [bold]{valueX}[/]"
                  },
                  "visible": true,
                  "xAxis": "customTime",
                  "yAxis": "Label",
                  "zIndex": 0
                }
              ],
              "style": {
                "overflow": "visible"
              },
              "subtitle": {
                "appearance": {
                  "color": "#807979",
                  "padding": {
                    "bottom": 5
                  }
                }
              },
              "title": {
                "appearance": {
                  "font": {
                    "size": 20
                  },
                  "padding": {
                    "bottom": 10
                  }
                }
              },
              "xAxes": [
                {
                  "appearance": {
                    "font": {
                      "size": "",
                      "weight": 500
                    },
                    "grid": {
                      "color": "",
                      "dashArray": "",
                      "minDistance": null,
                      "opacity": 1,
                      "position": 1
                    },
                    "inside": false,
                    "labels": {
                      "color": "",
                      "horizontalCenter": "middle",
                      "opacity": 1,
                      "rotation": 0,
                      "verticalCenter": "middle",
                      "wrap": true
                    },
                    "opposite": false
                  },
                  "category": {
                    "break": {
                      "enabled": false,
                      "endCategory": "",
                      "size": 0.05,
                      "startCategory": ""
                    }
                  },
                  "date": {
                    "baseInterval": {
                      "count": 1,
                      "enabled": false,
                      "skipEmptyPeriods": false,
                      "timeUnit": "hour"
                    },
                    "break": {
                      "enabled": false,
                      "endDate": "",
                      "size": 0.05,
                      "startDate": ""
                    },
                    "format": "hh:mm a",
                    "inputFormat": "yyyy-MM-dd kk:mm:ss",
                    "range": {
                      "max": "",
                      "min": "",
                      "useStrict": false
                    }
                  },
                  "inversed": false,
                  "label": {
                    "color": "",
                    "enabled": false,
                    "text": "Time"
                  },
                  "name": "customTime",
                  "render": "value",
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": false,
                    "format": "",
                    "pointerLength": 4,
                    "text": ""
                  },
                  "value": {
                    "break": {
                      "enabled": false,
                      "endValue": 100,
                      "size": 0.05,
                      "startValue": 0
                    },
                    "format": "#,###.##",
                    "logarithmic": false,
                    "range": {
                      "max": "",
                      "min": "",
                      "useStrict": false
                    }
                  },
                  "visible": true
                }
              ],
              "yAxes": [
                {
                  "appearance": {
                    "font": {
                      "size": "",
                      "weight": 500
                    },
                    "grid": {
                      "color": "",
                      "dashArray": "",
                      "minDistance": null,
                      "opacity": 1,
                      "position": 0
                    },
                    "inside": false,
                    "labels": {
                      "color": "",
                      "horizontalCenter": "middle",
                      "opacity": 1,
                      "rotation": 0,
                      "verticalCenter": "middle",
                      "wrap": true
                    },
                    "opposite": false
                  },
                  "category": {
                    "break": {
                      "enabled": false,
                      "endCategory": "",
                      "size": 0.05,
                      "startCategory": ""
                    }
                  },
                  "date": {
                    "baseInterval": {
                      "count": 1,
                      "enabled": false,
                      "skipEmptyPeriods": false,
                      "timeUnit": "hour"
                    },
                    "break": {
                      "enabled": false,
                      "endDate": "",
                      "size": 0.05,
                      "startDate": ""
                    },
                    "format": "M/d/yyyy HH:mm:ss",
                    "inputFormat": "yyyy-MM-dd kk:mm:ss",
                    "range": {
                      "max": "",
                      "min": "",
                      "useStrict": false
                    }
                  },
                  "inversed": true,
                  "label": {
                    "color": "",
                    "enabled": false,
                    "text": ""
                  },
                  "name": "Label",
                  "render": "category",
                  "tooltip": {
                    "background": {
                      "color": "",
                      "opacity": 1
                    },
                    "cornerRadius": 3,
                    "enabled": true,
                    "format": "",
                    "pointerLength": 4,
                    "text": ""
                  },
                  "value": {
                    "break": {
                      "enabled": false,
                      "endValue": 100,
                      "size": 0.05,
                      "startValue": 0
                    },
                    "format": "#,###.##",
                    "logarithmic": false,
                    "range": {
                      "max": "",
                      "min": "",
                      "useStrict": false
                    }
                  },
                  "visible": true
                }
              ]
            },
            "type": "ia.chart.xy"
          },
          {
            "meta": {
              "name": "mesAnalysisController"
            },
            "position": {
              "basis": "64px",
              "display": false
            },
            "propConfig": {
              "custom.end": {
                "binding": {
                  "config": {
                    "fallbackDelay": 2.5,
                    "mode": "expression",
                    "tagPath": "runScript(\u0027shared.mes.schedule.getTagPathForTimePeriodEnd\u0027, 0, {view.params.timePeriod}, {view.params.equipmentPath})"
                  },
                  "transforms": [
                    {
                      "code": "\tif not value:\n\t\treturn system.date.now()\n\treturn value",
                      "type": "script"
                    }
                  ],
                  "type": "tag"
                }
              },
              "custom.start": {
                "binding": {
                  "config": {
                    "fallbackDelay": 2.5,
                    "mode": "expression",
                    "tagPath": "runScript(\u0027shared.mes.schedule.getTagPathForTimePeriodStart\u0027, 0, {view.params.timePeriod}, {view.params.equipmentPath})"
                  },
                  "transforms": [
                    {
                      "code": "\tif not value:\n\t\treturn system.date.addMinutes(system.date.now(), -2)\n\treturn value",
                      "type": "script"
                    }
                  ],
                  "type": "tag"
                }
              },
              "custom.update": {
                "binding": {
                  "config": {
                    "struct": {
                      "end": "{this.custom.end}",
                      "eqPath": "{view.params.equipmentPath}",
                      "period": "{view.params.timePeriod}",
                      "start": "{this.custom.start}"
                    },
                    "waitOnAll": true
                  },
                  "transforms": [
                    {
                      "code": "\tself.props.endDate  \u003d value[\"end\"]\n\tself.props.startDate \u003d value[\"start\"]\n\treturn value",
                      "type": "script"
                    }
                  ],
                  "type": "expr-struct"
                }
              },
              "props.data": {
                "onChange": {
                  "enabled": null,
                  "script": "\tif currentValue.value:\n\t\tself.getSibling(\"XYChart_1\").props.dataSources \u003d system.dataset.toDataSet([], [])\n\t\tds \u003d currentValue.value\n\t\tif ds.getRowCount() \u003e 0:\n\t\t\telapsedTime \u003d ds.getValueAt(0, \u0027Elapsed Time\u0027)\n\t\t\tplannedDowntime \u003d ds.getValueAt(0, \u0027Planned Downtime\u0027)\n\t\t\tplannedTime \u003d elapsedTime - plannedDowntime\n\t\t\tunplannedDowntime \u003d ds.getValueAt(0, \u0027Unplanned Downtime\u0027)\n\t\t\tstandardRate \u003d ds.getValueAt(0, \u0027Standard Rate\u0027)\n\t\t\truntime \u003d ds.getValueAt(0, \u0027Runtime\u0027)\n\t\t\tplannedtime \u003d elapsedTime - plannedDowntime\n\t\t\tif plannedTime \u003d\u003d 0:\n\t\t\t\tplannedTime \u003d None\n\t\t\tif plannedDowntime \u003d\u003d 0:\n\t\t\t\tplannedDowntime \u003d None\n\t\t\toutfeedCount \u003d ds.getValueAt(0, \u0027OEE Outfeed Count\u0027)\n\t\t\trejectCount \u003d ds.getValueAt(0, \u0027OEE Reject Count\u0027)\n\t\t\tif standardRate \u003e 0:\n\t\t\t\tperfTime \u003d outfeedCount / standardRate\n\t\t\t\tqualTime \u003d rejectCount / standardRate\n\t\t\t\t\n\t\t\t\theader \u003d [\"Label\",\"Time\",\"Planned Downtime\",\"Unplanned Downtime\",\"Performance Loss\",\"Quality Loss\"]\n\t\t\t\tdata \u003d [[\u0027Elapsed Time\u0027, elapsedTime, None, None, None,None]]\n\t\t\t\tdata.append([\u0027Planned Time\u0027, plannedTime, plannedDowntime, None,None, None])\n\t\t\t\tdata.append([\u0027Run Time\u0027, runtime, None, unplannedDowntime, None, None])\n\t\t\t\tdata.append([\u0027Production Time\u0027, runtime - perfTime, None, None, perfTime, None])\n\t\t\t\tdata.append([\u0027Quality Time\u0027, runtime - perfTime - qualTime, None,None, None, qualTime])\n\t\t\t\tnewDS \u003d system.dataset.toDataSet(header, data)\n\t\t\t\tnewDS \u003d system.dataset.toDataSet(header, data)\n\t\t\t\tdataSet \u003d system.dataset.toPyDataSet(newDS)\n\t\t\t\treturnResult \u003d []\n\t\t\t\tfor row in dataSet:\n\t\t\t\t\tresult \u003d {}\n\t\t\t\t\tfor index,data in enumerate(row):\n\t\t\t\t\t\tresult[str(dataSet.getColumnName(index))] \u003d data\n\t\t\t\t\treturnResult.append(result)\n\t\t\t\tself.getSibling(\"XYChart_1\").props.dataSources \u003d {\u0027oeeData\u0027:returnResult}"
                }
              },
              "props.endDate": {
                "persistent": false
              },
              "props.filterParams[0].value": {
                "binding": {
                  "config": {
                    "path": "view.params.equipmentPath"
                  },
                  "type": "property"
                },
                "persistent": true
              },
              "props.startDate": {
                "persistent": false
              }
            },
            "props": {
              "data": {
                "$": [
                  "ds",
                  192,
                  1712785384432
                ],
                "$columns": []
              },
              "drillDownOptions": {
                "$": [
                  "ds",
                  192,
                  1712785384432
                ],
                "$columns": []
              },
              "executionTime": 132,
              "filterParams": [
                {
                  "param": "eqPath",
                  "type": "string",
                  "value": "Enterprise\\El Dorado Hills\\Packaging Area\\Packaging Line 1"
                }
              ],
              "message": "The selectedAnalysisName (OEE Losses Waterfall) doesn\u0027t have a valid value. The name requested doesn\u0027t match a saved analysis.",
              "refreshOnSettingsChange": true,
              "selectedAnalysisName": "OEE Losses Waterfall"
            },
            "type": "mes.production.mesAnalysisController"
          }
        ],
        "meta": {
          "name": "runtime",
          "tooltip": {
            "enabled": true
          }
        },
        "position": {
          "grow": 1,
          "shrink": 0
        },
        "propConfig": {
          "position.display": {
            "binding": {
              "config": {
                "expression": "!{view.params.configuring}"
              },
              "type": "expr"
            },
            "persistent": true
          }
        },
        "props": {
          "style": {
            "overflow": "visible"
          }
        },
        "type": "ia.container.flex"
      }
    ],
    "meta": {
      "name": "root"
    },
    "props": {
      "direction": "column",
      "style": {
        "overflow": "visible"
      }
    },
    "type": "ia.container.flex"
  }
}